//+------------------------------------------------------------------+
//|                                       smC4Scalper Signals_v1.mq4 |
//|                                            2009.07.13, SwingMan |
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright " 2009.07.13, SwingMan"
#property link      ""
//  Source:
//+------------------------------------------------------------------+
//|                                                         TRIX.mq4 |
//|                                                          by Raff | 
//+------------------------------------------------------------------+ 
//#property copyright "Copyright  2006, raff1410@o2.pl"

// Source: smSuper TRIX_v1
/* 2009.07.12 - choice of moving averages
              - choice of prices (close, log(close) )    
*/
//---- indicator settings
#property  indicator_chart_window

#property  indicator_buffers 2
#property  indicator_color1 DeepSkyBlue
#property  indicator_color2 Magenta

#property  indicator_width1 1
#property  indicator_width2 1

//---- indicator parameters
//-------------------------------------------------------------------
extern bool UseMA  = false;  // For Indrek, allow turn off of  MA checking
extern int Period_Avg   = 13;
extern int  TRIX_Period = 2;
extern double WaitingTime_Minutes = 0.0;
extern string _____TRIX_Averages_____ = "0=SMA, 1=EMA, 2=SMMA, 3=LWMA";
extern int Mode_Average_1 = 1;
extern int Mode_Average_2 = 1;
extern int Mode_Average_3 = 1;
extern string _____TRIX_Input_Price_____ = "0=C,4=Median,5=Typical,6=Weighted";
extern int Input_Price = 0;
extern string ____Cross_Average_____ = "";
extern int ma_method = 3;
extern int applied_price = 6;
extern string p2 = "_____Signals_____";
extern bool Alert_Signals     = false;
extern bool EMail_Signals     = false;
extern int  CountBars         = 500;
//-------------------------------------------------------------------
int  Signal_Period     = 0;
double Scale = 1000.0;

//---- indicator buffers
double      ind_buffer1a[];
double      ind_buffer2a[];
double      ind_buffer3[];
double      ind_buffer4[];
double      ind_buffer5[];
double      ind_buffer6up[];
double      ind_buffer6dn[];
double      ind_buffer7[];
double SignalUP[], SignalDN[];

//---- variables
bool TurnedUp = false;
bool TurnedDown = false;  
int ModeAvg1, ModeAvg2, ModeAvg3;
int inputPrice;
double dWaitingTime;
datetime timeCrossUP=0, timeCrossDN=0,  timeTrixUP=0, timeTrixDN=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   ArraySetAsSeries(ind_buffer1a,true);
   ArraySetAsSeries(ind_buffer2a,true);
   ArraySetAsSeries(ind_buffer7,true);   
   ArraySetAsSeries(ind_buffer5,true);
   ArraySetAsSeries(ind_buffer6up,true);
   ArraySetAsSeries(ind_buffer6dn,true);
   ArraySetAsSeries(ind_buffer3,true);
   ArraySetAsSeries(ind_buffer4,true);
   
//---- indicator buffers mapping
   IndicatorDigits(Digits);
   SetIndexBuffer(0,SignalUP); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,233); SetIndexLabel(0,"C4Scalp Up");
   SetIndexBuffer(1,SignalDN); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,234); SetIndexLabel(1,"C4Scalp Down");  
   
//---- parameters
   //-- default
   ModeAvg1 = MODE_SMMA;
   ModeAvg2 = MODE_SMMA;
   ModeAvg3 = MODE_EMA;
   inputPrice = PRICE_CLOSE;
   
   //-- TRIX studies
   string sPrice, sAvg1, sAvg2, sAvg3;
   //moving averages
   switch (Mode_Average_1) {
      case 0: ModeAvg1 = MODE_SMA;  sAvg1 = "S"; break;
      case 1: ModeAvg1 = MODE_EMA;  sAvg1 = "E"; break;
      case 2: ModeAvg1 = MODE_SMMA; sAvg1 = "M"; break;
      case 3: ModeAvg1 = MODE_LWMA; sAvg1 = "W"; break;
   }
   switch (Mode_Average_2) {
      case 0: ModeAvg2 = MODE_SMA;  sAvg2 = "S"; break;
      case 1: ModeAvg2 = MODE_EMA;  sAvg2 = "E"; break;
      case 2: ModeAvg2 = MODE_SMMA; sAvg2 = "M"; break;
      case 3: ModeAvg2 = MODE_LWMA; sAvg2 = "W"; break;
   }
   switch (Mode_Average_3) {
      case 0: ModeAvg3 = MODE_SMA;  sAvg3 = "S"; break;
      case 1: ModeAvg3 = MODE_EMA;  sAvg3 = "E"; break;
      case 2: ModeAvg3 = MODE_SMMA; sAvg3 = "M"; break;
      case 3: ModeAvg3 = MODE_LWMA; sAvg3 = "W"; break;
   }
   //-- prices
   switch(Input_Price) {
      case 0: inputPrice = PRICE_CLOSE;    sPrice = "C"; break;
      case 4: inputPrice = PRICE_MEDIAN;   sPrice = "M"; break;
      case 5: inputPrice = PRICE_TYPICAL;  sPrice = "T"; break;
      case 6: inputPrice = PRICE_WEIGHTED; sPrice = "W"; break;
   }
  
//---- name for DataWindow and indicator subwindow label
   string sParameters = ", "+sAvg1+","+sAvg2+","+sAvg3+", "+sPrice + "; "+Period_Avg;
   string sName = "smC4Scalper Signals_v1 ("+TRIX_Period+sParameters+")";
   IndicatorShortName(sName);
   Comment(sName);

//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| TRIX                                                             |
//+------------------------------------------------------------------+
int start()
{
string st;
   if (TRIX_Period==Signal_Period) return(0);

   ArrayResize(ind_buffer1a,Bars);
   ArrayResize(ind_buffer2a,Bars);
   ArrayResize(ind_buffer7,Bars);   
   ArrayResize(ind_buffer5,Bars);
   ArrayResize(ind_buffer6up,Bars);
   ArrayResize(ind_buffer6dn,Bars);
   ArrayResize(ind_buffer3,Bars);
   ArrayResize(ind_buffer4,Bars);
      
   int i, limit=CountBars;
   if (limit>Bars) limit=Bars-1;

//---- trix    
   //-- calculation
   for(i=0; i<limit; i++) ind_buffer1a[i]=iMA(Symbol(),Period(),TRIX_Period,0,ModeAvg1,inputPrice,i);
   for(i=0; i<limit; i++) ind_buffer2a[i]=iMAOnArray(ind_buffer1a,0,TRIX_Period,0,ModeAvg2,i);
   for(i=0; i<limit; i++) ind_buffer7[i] =iMAOnArray(ind_buffer2a,0,TRIX_Period,0,ModeAvg3,i);
   //-- TRIX
   for(i=0; i<limit-1; i++) {
      //-- Rate of change
      if (ind_buffer7[i+1] != 0)
            ind_buffer1a[i] = Scale * (ind_buffer7[i]-ind_buffer7[i+1]) / ind_buffer7[i+1];
   }
   
   for(i=0; i<limit-1; i++) ind_buffer2a[i]=iMAOnArray(ind_buffer1a,0,Signal_Period,0,MODE_EMA,i);

   for(i=0; i<limit-1; i++) {
      double diff = ind_buffer1a[i]-ind_buffer2a[i];
      ind_buffer5[i]=diff;
      if (diff >= 0) {
         ind_buffer6up[i]=diff;
         ind_buffer6dn[i]=EMPTY_VALUE;
      }
      else {
         ind_buffer6up[i]  =EMPTY_VALUE;
         ind_buffer6dn[i]=diff;
      }
   }

//---- Alert Signals
   i=limit-1;
   while(i>=0)
   {
      double dATR = iATR(Symbol(),Period(),10,i)*0.5;
      //-- draw signals .............................................      
      int shift = 0;         
      SignalUP[i+shift] = EMPTY_VALUE;
      SignalDN[i+shift] = EMPTY_VALUE;
      //-- 1. TRIX long/short conditions
      bool bSignalUP = (ind_buffer6up[i+shift] > 0 && ind_buffer6up[i+shift] != EMPTY_VALUE && ind_buffer6dn[i+1+shift] < 0);      
      bool bSignalDN = (ind_buffer6dn[i+shift] < 0 && ind_buffer6up[i+1+shift] != EMPTY_VALUE && ind_buffer6up[i+1+shift] > 0);
      
      /*if (i == 0) {
         if (bSignalUP == true) {
            if (timeTrixUP == 0) {
               timeTrixUP = TimeCurrent();
               timeTrixDN = 0;
            }
         }
         if (bSignalDN == true) {
            if (timeTrixDN == 0) {
               timeTrixUP = 0;
               timeTrixDN = TimeCurrent();
            }
         }
         //if (bSignalUP == false and bSignalDN == false) {
         //   timeTrixUP = 0;
         //   timeTrixDN = 0;            
         //}
      }*/
      
      if (bSignalUP == true) {
         if (timeTrixUP == 0) {
            timeTrixUP = iTime(Symbol(),Period(),i+shift);
            timeTrixDN = 0;
         }
      }
      if (bSignalDN == true) {
         if (timeTrixDN == 0) {
            timeTrixUP = 0;
            timeTrixDN = iTime(Symbol(),Period(),i+shift);
         }
      }
      
      //-- 2. AVERAGE long/short condition
      double dAverage = iMA(Symbol(),Period(),Period_Avg,0,ma_method,applied_price,i+shift);
      double dClose   = iClose(Symbol(),Period(),i+shift);      
      //double dHigh  = iHigh(Symbol(),Period(),i+shift);
      //double dLow   = iLow(Symbol(),Period(),i+shift);
      bool bCrossUP = dClose > dAverage;
      bool bCrossDN = dClose < dAverage;
      
//if (iTime(Symbol(),Period(),i+shift)==D'2009.07.13 15:45')
//Comment("dClose= ",dClose," dAverage= ",dAverage);
      /*if (i == 0) {
         if (bCrossUP == true) {
            if (timeCrossUP == 0) {
               timeCrossUP = TimeCurrent();
               timeCrossDN = 0;
            }
         }
         if (bCrossDN == true) {
            if (timeCrossDN == 0) {
               timeCrossUP = 0;
               timeCrossDN = TimeCurrent();
            }
         }
      }*/
      
      if (bCrossUP == true) {
         if (timeCrossUP == 0) {
            timeCrossUP = iTime(Symbol(),Period(),i+shift);
            timeCrossDN = 0;
         }
      }
      if (bCrossDN == true) {
         if (timeCrossDN == 0) {
            timeCrossUP = 0;
            timeCrossDN = iTime(Symbol(),Period(),i+shift);
         }
      }
      
      //-- 3. TIME condition
      bool bTimeCondition = false;
      datetime timeFromCross, timeFromTrix;
      /*if (i == 0) {
         //-- long 
         if (bSignalUP == true && bCrossUP == true) {
            timeFromCross = TimeCurrent() - timeCrossUP;
            timeFromTrix  = TimeCurrent() - timeTrixUP;
            bTimeCondition = (timeFromCross >= dWaitingTime) && (timeFromTrix >= dWaitingTime);
         }
         else
         //-- short
         if (bSignalDN == true && bCrossDN == true) {
            timeFromCross = TimeCurrent() - timeCrossDN;
            timeFromTrix  = TimeCurrent() - timeTrixDN;
            bTimeCondition = (timeFromCross >= dWaitingTime) && (timeFromTrix >= dWaitingTime);
         }
      }*/

/*st =     "timeCrossUP=     " + TimeToStr(timeCrossUP,TIME_MINUTES|TIME_SECONDS) + "\n";
st = st +"timeFromCrossUP= " + TimeToStr(TimeCurrent()-timeCrossUP,TIME_MINUTES|TIME_SECONDS) + "\n";
st = st +"timeCrossDN=     " + TimeToStr(timeCrossDN,TIME_MINUTES|TIME_SECONDS) + "\n";
st = st +"timeFromCrossDN= " + TimeToStr(TimeCurrent()-timeCrossDN,TIME_MINUTES|TIME_SECONDS) + "\n\n";
st = st +"timeTrixUP=     " + TimeToStr(timeTrixUP,TIME_MINUTES|TIME_SECONDS) + "\n";
st = st +"timeFromTrixUP= " + TimeToStr(TimeCurrent()-timeTrixUP,TIME_MINUTES|TIME_SECONDS) + "\n";
st = st +"timeTrixDN=     " + TimeToStr(timeTrixDN,TIME_MINUTES|TIME_SECONDS) + "\n";
st = st +"timeFromTrixDN= " + TimeToStr(TimeCurrent()-timeTrixDN,TIME_MINUTES|TIME_SECONDS) + "\n\n";
Comment(st);*/

      //-- long 
      if ((bSignalUP == true && bCrossUP == true) || (bSignalUP == true &&  UseMA == false)) { // For Indrek
         timeFromCross = iTime(Symbol(),Period(),i+shift) - timeCrossUP;
         timeFromTrix  = iTime(Symbol(),Period(),i+shift) - timeTrixUP;
         bTimeCondition = (timeFromCross >= dWaitingTime) && (timeFromTrix >= dWaitingTime);
      }
      else
      //-- short
      if ((bSignalDN == true && bCrossDN == true) || (bSignalDN == true &&  UseMA == false)) { // For Indrek
         timeFromCross = iTime(Symbol(),Period(),i+shift) - timeCrossDN;
         timeFromTrix  = iTime(Symbol(),Period(),i+shift) - timeTrixDN;
         bTimeCondition = (timeFromCross >= dWaitingTime) && (timeFromTrix >= dWaitingTime);
      }
      
      //-- 4. DRAW signals
      bool drawSignalUP, drawSignalDN;     
      drawSignalUP = ((bSignalUP == true) && (bCrossUP == true) && (bTimeCondition == true)) || ((bSignalUP == true) && (bTimeCondition == true) && (UseMA == false)); // For Indrek
      drawSignalDN = ((bSignalDN == true) && (bCrossDN == true) && (bTimeCondition == true)) || ((bSignalDN == true) && (bTimeCondition == true) && (UseMA == false)); // For Indrek    
      
      if (drawSignalUP == true) {
         SignalUP[i+shift] = Low[i+shift]-dATR;
         SignalDN[i+shift] = EMPTY_VALUE;
      }
      else
      
      if (drawSignalDN == true) {
         SignalUP[i+shift] = EMPTY_VALUE;
         SignalDN[i+shift] = High[i+shift]+dATR;
      }
/*         
      //-- repainting ? .............................................
      shift = 1;
      SignalUP[i+shift] = EMPTY_VALUE;
      SignalDN[i+shift] = EMPTY_VALUE;
      //-- 1. TRIX long/short conditions
      bSignalUP = (ind_buffer6up[i+shift] > 0 && ind_buffer6up[i+shift] != EMPTY_VALUE && ind_buffer6dn[i+1+shift] < 0);      
      bSignalDN = (ind_buffer6dn[i+shift] < 0 && ind_buffer6up[i+1+shift] != EMPTY_VALUE && ind_buffer6up[i+1+shift] > 0);

      if (bSignalUP == true) {
         SignalUP[i+shift] = Low[i+shift]-dATR;
         SignalDN[i+shift] = EMPTY_VALUE;
      }
      if (bSignalDN == true) {
         SignalUP[i+shift] = EMPTY_VALUE;
         SignalDN[i+shift] = High[i+shift]+dATR;
      }
*/     
      
      //-- alerts (original conditions)       
      string sPeriod = Get_sPeriod(Period());
      if ( i== 0){
         if (Alert_Signals==true || EMail_Signals == true) {
            if (drawSignalUP && TurnedUp==false)  {  
               st = "C4Scalping BUY:  "+Symbol()+"-"+sPeriod+"  at  "+ DoubleToStr(Close[0],Digits)+"  ("+ TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS)+")";
               if (Alert_Signals == true) Alert(st);            
               if (EMail_Signals == true) SendMail("C4Scalping alert",st);
               TurnedDown = false;
               TurnedUp   = true;
            } 
            else
            if (drawSignalDN && TurnedDown==false) {  
               st = "C4Scalping SELL:  "+Symbol()+"-"+sPeriod+"  at  "+ DoubleToStr(Close[0],Digits)+"  ("+ TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS)+")";
               if (Alert_Signals == true) Alert(st);            
               if (EMail_Signals == true) SendMail("C4Scalping alert",st);
               TurnedDown = true;
               TurnedUp   = false;
            } 
         }
      }
      /*if (Alert_Signals==true || EMail_Signals == true) {
         if (ind_buffer2a[i]<ind_buffer1a[i] && ind_buffer2a[i+1]>=ind_buffer1a[i+1]) ind_buffer3[i]=ind_buffer2a[i]-0.0001;
         if (ind_buffer2a[i]>ind_buffer1a[i] && ind_buffer2a[i+1]<=ind_buffer1a[i+1]) ind_buffer4[i]=ind_buffer2a[i]+0.0001;
     
         if (ind_buffer3[0]==ind_buffer2a[0]-0.0001 && TurnedUp==false)  {  
            st = "C4Scalping BUY:  "+Symbol()+"-"+sPeriod+"  at  "+ Close[0]+"  "+ TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS);
            if (Alert_Signals == true) Alert(st);            
            if (EMail_Signals == true) SendMail("C4Scalping alert",st);
            TurnedDown = false;
            TurnedUp   = true;
         } 
         if (ind_buffer4[0]==ind_buffer2a[0]+0.0001 && TurnedDown==false) {  
            st = "C4Scalping SELL:  "+Symbol()+"-"+sPeriod+"  at  "+ Close[0]+"  "+ TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS);
            if (Alert_Signals == true) Alert(st);            
            if (EMail_Signals == true) SendMail("C4Scalping alert",st);
            TurnedDown = true;
            TurnedUp   = false;
         } 
      }*/
      
   i--;
   }
//---- done
   return(0);
}


//+------------------------------------------------------------------+
//    Get sPeriod
//+------------------------------------------------------------------+
string Get_sPeriod(int timeframe)
{
   if (timeframe == PERIOD_M1) return("M1");
   if (timeframe == PERIOD_M5) return("M5");
   if (timeframe == PERIOD_M15) return("M15");
   if (timeframe == PERIOD_M30) return("M30");
   if (timeframe == PERIOD_H1) return("H1");
   if (timeframe == PERIOD_H4) return("H4");
   if (timeframe == PERIOD_D1) return("D1");
   if (timeframe == PERIOD_W1) return("W1");
   if (timeframe == PERIOD_MN1) return("MN1");
}