//+------------------------------------------------------------------+
//|                                                       smTRIX.mq4 |
//|                                            2009.07.06, SwingMan |
//|                                                                  | 
//+------------------------------------------------------------------+ 
#property copyright " 2009.09.06, SwingMan"
#property link      ""
//  Source:
//+------------------------------------------------------------------+
//|                                                         TRIX.mq4 |
//|                                                          by Raff | 
//+------------------------------------------------------------------+ 
//#property copyright "Copyright  2006, raff1410@o2.pl"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1 Gray
#property  indicator_color2 Green
#property  indicator_color3 Red

#property  indicator_width1 1
#property  indicator_width2 5
#property  indicator_width3 5

#property  indicator_style1 STYLE_SOLID
#property  indicator_style2 STYLE_SOLID
#property  indicator_style3 STYLE_SOLID

#property  indicator_level1 0

//---- indicator parameters
//-------------------------------------------------------------------
extern int  TRIX_Period       = 3;
extern int  Signal_Period     = 0;
extern bool Signals           = false;
extern int  CountBars         = 1500;
//-------------------------------------------------------------------

//---- indicator buffers
double      ind_buffer1a[];
double      ind_buffer2a[];
double      ind_buffer3[];
double      ind_buffer4[];
double      ind_buffer5[];
double      ind_buffer6up[];
double      ind_buffer6dn[];
double      ind_buffer7[];

//---- variables
static bool TurnedUp = false;
static bool TurnedDown = false;  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   ArraySetAsSeries(ind_buffer1a,true);
   ArraySetAsSeries(ind_buffer2a,true);
   ArraySetAsSeries(ind_buffer7,true);
   
//---- indicator buffers mapping
   IndicatorBuffers(5);
   SetIndexBuffer(0,ind_buffer5); SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,NULL);
   SetIndexBuffer(1,ind_buffer6up); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ind_buffer6dn); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ind_buffer3);
   SetIndexBuffer(4,ind_buffer4);
  
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("smTRIX ("+TRIX_Period+", "+Signal_Period+")");
   SetIndexLabel(1,"TRIX up");
   SetIndexLabel(2,"TRIX dn");

//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| TRIX                                                             |
//+------------------------------------------------------------------+
int start()
{
   if (TRIX_Period==Signal_Period) return(0);

   ArrayResize(ind_buffer1a,Bars);
   ArrayResize(ind_buffer2a,Bars);
   ArrayResize(ind_buffer7,Bars);
      
   int i, limit=CountBars;
   if (limit>Bars) limit=Bars-1;

//---- trix 
   for(i=0; i<limit; i++) ind_buffer1a[i]=iMA(NULL,0,TRIX_Period,0,MODE_SMMA,PRICE_CLOSE,i);
   for(i=0; i<limit; i++) ind_buffer2a[i]=iMAOnArray(ind_buffer1a,0,TRIX_Period,0,MODE_SMMA,i);
   for(i=0; i<limit; i++) ind_buffer7[i]=iMAOnArray(ind_buffer2a,0,TRIX_Period,0,MODE_EMA,i);
   
   for(i=0; i<limit-1; i++) ind_buffer1a[i]=(ind_buffer7[i]-ind_buffer7[i+1])/ind_buffer7[i+1];
   for(i=0; i<limit-1; i++) ind_buffer2a[i]=iMAOnArray(ind_buffer1a,0,Signal_Period,0,MODE_EMA,i);
   for(i=0; i<limit-1; i++) {
      double diff = ind_buffer1a[i]-ind_buffer2a[i];
      ind_buffer5[i]=diff;
      if (diff >= 0) {
         ind_buffer6up[i]=diff;
         ind_buffer6dn[i]=EMPTY_VALUE;
      }
      else {
         ind_buffer6up[i]  =EMPTY_VALUE;
         ind_buffer6dn[i]=diff;
      }
   }

//---- signals
   i=limit-1;
   while(i>=0)
   {
     if (Signals==true)
     {
     if (ind_buffer2a[i]<ind_buffer1a[i] && ind_buffer2a[i+1]>=ind_buffer1a[i+1]) ind_buffer3[i]=ind_buffer2a[i]-0.0001;
     if (ind_buffer2a[i]>ind_buffer1a[i] && ind_buffer2a[i+1]<=ind_buffer1a[i+1]) ind_buffer4[i]=ind_buffer2a[i]+0.0001;
     
     if (ind_buffer3[0]==ind_buffer2a[0]-0.0001 && TurnedUp==false)
        {  
              Alert("Trix Buy:  ",Symbol()," - ",Period(),"  at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));
              TurnedDown = false;
              TurnedUp = true;
        } 
     if (ind_buffer4[0]==ind_buffer2a[0]+0.0001 && TurnedDown==false)
        {  
              Alert("Trix SELL:  ",Symbol()," - ",Period(),"  at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));
              TurnedUp = false;
              TurnedDown = true;
        } 
     }
   i--;
   }
//---- done
   return(0);
}